package ru.redguy.webinfomod;

import com.google.gson.JsonObject;
import com.google.gson.JsonParser;
import org.spongepowered.api.Sponge;

import java.io.*;
import java.util.HashMap;
import java.util.Map;

public class Config {

    private JsonObject jsonObject;
    private Logger logger;

    public Config(Logger logger) throws IOException {
        this.logger = logger;
        JsonParser parser = new JsonParser();
        Object obj = null; //читаем JSON файл
        try {
            obj = parser.parse(new FileReader("config/WebInfoMod.json"));
        } catch (FileNotFoundException e) {
            File f = new File("config/WebInfoMod.json");
            f.createNewFile();
            FileWriter fw = new FileWriter(f);
            fw.write(
                    "{"+System.lineSeparator()+
                            "\"WebPort\":8080,"+System.lineSeparator()+
                            "\"lang\":\"ru\""+System.lineSeparator()+
                            "}"
            );
            fw.close();
            obj = parser.parse(new FileReader("config/WebInfoMod.json"));
        }
        jsonObject = (JsonObject) obj;
        jsonObject.addProperty("MineV",Sponge.getPlatform().getMinecraftVersion().getName());
    }

    public String getString(String name) {
        return jsonObject.get(name).getAsString();
    }

    public int getInt(String name) {
        return jsonObject.get(name).getAsInt();
    }

    public Logger getLogger() {
        return logger;
    }
}
