package ru.redguy.webinfomod;

import com.google.inject.Inject;
import org.slf4j.Logger;
import org.spongepowered.api.event.game.state.GameStartedServerEvent;
import org.spongepowered.api.event.Listener;
import org.spongepowered.api.plugin.Plugin;
import ru.redguy.webinfomod.langs.Localization;
import ru.redguy.webinfomod.utils.BasePlaceholders;
import ru.redguy.webinfomod.utils.PlaceholdersUtils;

import java.io.IOException;

@Plugin(
        id = "webinfomod",
        name = "WebInfoSponge",
        description = "This здгпшт allows you to view data about  your server, as well as manage it by authorization. Change game settings, execute commands, and much more.",
        url = "https://redguy.ru",
        authors = {
                "RedGuyGames"
        }
)
public class WebInfoSponge {

    @Inject
    private Logger logger;

    public ru.redguy.webinfomod.Logger myLogger;
    public Config config;
    public WebServer webServer;

    @Listener
    public void onServerStart(GameStartedServerEvent event) throws IOException {
        myLogger = new ru.redguy.webinfomod.Logger(logger);
        config = new Config(myLogger);
        Localization.loadLangFile(config);
        BasePlaceholders.registerBase();
        UsersConfig.loadUsers();
        webServer = new WebServer(config.getInt("WebPort"), config);
    }
}
