package ru.redguy.webinfomod.pages.auth;

import fi.iki.elonen.NanoHTTPD;
import ru.redguy.webinfomod.*;
import ru.redguy.webinfomod.langs.Localization;
import ru.redguy.webinfomod.utils.WebUtils;

import java.io.IOException;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@WebPage(url = "/auth/worker")
public class Worker implements IWebPage {
    public NanoHTTPD.Response getPage(Config config, NanoHTTPD.IHTTPSession session) throws IOException {
        try {
            session.parseBody(new HashMap<String, String>());
        } catch (NanoHTTPD.ResponseException e) {
            e.printStackTrace();
        }
        Map<String, List<String>> decodedQueryParameters = WebUtils.decodeParams(session.getQueryParameterString());
        if(!decodedQueryParameters.containsKey("user")) {
            NanoHTTPD.Response response = NanoHTTPD.newFixedLengthResponse(NanoHTTPD.Response.Status.REDIRECT_SEE_OTHER,NanoHTTPD.MIME_PLAINTEXT,"");
            response.addHeader("Location","/auth/");
            return response;
        } else {
            if(!decodedQueryParameters.containsKey("password")) {
                NanoHTTPD.Response response = NanoHTTPD.newFixedLengthResponse(NanoHTTPD.Response.Status.REDIRECT_SEE_OTHER,NanoHTTPD.MIME_PLAINTEXT,"");
                response.addHeader("Location","/auth/");
                return response;
            } else {
                User user = UsersConfig.getUser(decodedQueryParameters.get("user").get(0));
                if(user == null) {
                    NanoHTTPD.Response response = NanoHTTPD.newFixedLengthResponse(NanoHTTPD.Response.Status.REDIRECT_SEE_OTHER,NanoHTTPD.MIME_PLAINTEXT,"");
                    response.addHeader("Location", "/auth/");
                    return response;
                } else {
                    if (!user.password.equals(decodedQueryParameters.get("password").get(0))) {
                        NanoHTTPD.Response response = NanoHTTPD.newFixedLengthResponse(NanoHTTPD.Response.Status.REDIRECT_SEE_OTHER,NanoHTTPD.MIME_PLAINTEXT,"");
                        response.addHeader("Location", "/auth/");
                        return response;
                    } else {
                        Date date = new Date();
                        String token = WebUtils.MD5(date.getTime()+"MagickSalt");
                        WebUtils.CookieHandler ch = new WebUtils.CookieHandler(session.getHeaders());
                        ch.set("session",token,1);
                        WebStatic.sessions.put(token,user.user);
                        NanoHTTPD.Response response = NanoHTTPD.newFixedLengthResponse(NanoHTTPD.Response.Status.REDIRECT_SEE_OTHER,NanoHTTPD.MIME_PLAINTEXT,"");
                        response.addHeader("Location", "/");
                        ch.unloadQueue(response);
                        config.getLogger().info(LoggerType.Web,user.user + " login!");
                        return response;
                    }
                }
            }
        }
    }
}
