package ru.redguy.webinfomod.utils;

import ru.redguy.webinfomod.Logger;
import ru.redguy.webinfomod.WebStatic;
import ru.redguy.webinfomod.langs.Localization;
import ru.redguy.webinfomod.langs.enums.Links;
import ru.redguy.webinfomod.langs.enums.RootCategories;

import java.util.Arrays;
import java.util.Objects;

public class BasePlaceholders {
    public static void registerBase() {
        PlaceholdersUtils.registerPlaceholder("auth", new Placeholder() {
            @Override
            public String getContent(String[] args, PlaceholdersUtils placeholdersUtils) {
                WebUtils.CookieHandler ch = new WebUtils.CookieHandler(placeholdersUtils.getSession().getHeaders());
                if(!WebStatic.sessions.containsKey(ch.read("session"))) {
                    return "<a href=\"auth/\" class=\"authLink\">"+ Localization.getCategory(RootCategories.Links).getString(Links.login)+"</a>";
                } else {
                    return "<a href=\"logout/\" class=\"authLink\">"+Localization.getCategory(RootCategories.Links).getString(Links.logout)+"</a><br>" +
                            "<a href=\"cp\" class=\"authLink\">"+Localization.getCategory(RootCategories.Links).getString(Links.controlPanel)+"</a>";
                }
            }
        });

        PlaceholdersUtils.registerPlaceholder("title", new Placeholder() {
            @Override
            public String getContent(String[] args, PlaceholdersUtils placeholdersUtils) {
                return Objects.requireNonNull(Localization.getCategory(RootCategories.Titles)).getString(args[0]);
            }
        });

        PlaceholdersUtils.registerPlaceholder("word", new Placeholder() {
            @Override
            public String getContent(String[] args, PlaceholdersUtils placeholdersUtils) {
                return Objects.requireNonNull(Localization.getCategory(RootCategories.Words)).getString(args[0]);
            }
        });
    }
}
